# GB_2312 Splitter for Zope
#********************************
# Atuthor: Wenshan Du
# Version: 0.1 Beta
# E-mail: info@dohao.org
# Homepage: http://www.dohao.org
#****************************************************************
# Copyright (c) Dohao.org and Contributors. All Rights Reserved.
#****************************************************************

import re, string
class GB_Splitter:

    def __init__(self, insrc, stop_word_dic={}):
        self.isrc = insrc
        self.src = []
        st=re.sub("<[^<^>]*>", "", self.isrc)
        self.zi=re.split('([\x80-\xFF][\x80-\xFF])|[\s\*]+', st)
        stop=('','','','','','','','','',
		'','','','','','','','','','',
		'','(',')',':',',','"',"'",'`','-','[',']')
		
        li=[]
        if not stop_word_dic:
            stop_word_dic = {}
        i=2
	if len(self.zi)==1 :
	    zil=self.zi[0]
	    if zil.isalpha() or zil.isdigit():
                self.src.append(zil)
	    elif zil.find('.')>=0 and zil.split('.')[0].isdigit() and zil.split('.')[1].isdigit():
		self.src.append(zil)
	    elif zil.find('.')>=0 and zil.split('.')[0].isalpha() and zil.split('.')[1].isalpha():
		self.src.append(zil)
        else:
	    for y in range(len(self.zi)-2):
		if self.zi[y]:
		    ziy=self.zi[y]
		    wo=self.zi[y].isalpha()
		    di=self.zi[y].isdigit()
		    if (wo==0) and  (di==0):
			ci=string.lower(self.zi[y])
			for z in (1,2):
			    if self.zi[y+z]:
				wo2=self.zi[y+z].isalpha()
				di2=self.zi[y+z].isdigit()
				if (wo2==0) and (di2==0):
				    ci=ci+string.lower(self.zi[y+z])
				else:
				    break
			if self.src.count(ci) <1:
			    self.src.append(ci)
		    if wo==1 and (self.src.count(ziy) <1):
			self.src.append(ziy.lower())
		    if di==1 and (self.src.count(ziy) <1):
			self.src.append(ziy)
		    if ziy.find('.')>=0 and ziy.split('.')[0].isalpha() and ziy.split('.')[1].isalpha():
			self.src.append(ziy)
        for s in range(len(self.src)):
            for st in stop:
                if string.find(self.src[s],st)>=0:
                    li.append(self.src[s])
        for l in li:
            try:
                self.src.remove(l)
            except:
                pass
    def __getslice__(self, a, b):
        return self.src[a:b]

    def __getitem__(self, a):
        return self.src[a]

    def __len__(self):
        return len(self.src)

    def indexes(self, a):
        res =[]
        for i in range(len(self.src)):
            if self.src[i]==a:
                res.append(i)
        return res

    def pos(self, a):
        s = self.src[a]
        m = re.search(s, self.isrc)
        return m.span()




